# For Haskell Packaging Guidelines see:
# - https://fedoraproject.org/wiki/Packaging:Haskell
# - https://fedoraproject.org/wiki/PackagingDrafts/Haskell

%global ffi_ver 0.0.2
%global filemanip_ver 0.3.6.3

Name:           Agda-stdlib
Version:        0.9
Release:        1%{?dist}
Summary:        Agda standard libraries

Group:          Development/Libraries
License:        MIT
URL:            http://wiki.portal.chalmers.se/agda/agda.php?n=Libraries.StandardLibrary
# dl from https://github.com/agda/agda-stdlib/archive/v%{version}.tar.gz
Source0:        agda-stdlib-%{version}.tar.gz
Source1:        http://hackage.haskell.org/package/filemanip-%{filemanip_ver}/filemanip-%{filemanip_ver}.tar.gz
BuildRequires:  ghc-Cabal-devel
%if 0%{?fedora} >= 20
BuildRequires: ghc-rpm-macros-extra
%else
BuildRequires: ghc-rpm-macros
%endif
BuildRequires:  Agda
# needed for filemanip
BuildRequires:  ghc-unix-compat-devel
# Agda needs ghci and is not building on arm currently
ExclusiveArch:  %{ghc_arches_with_ghci}
ExcludeArch:    armv7hl
Obsoletes:      ghc-agda-lib-ffi < 0.0.2-6, ghc-agda-lib-ffi-devel < 0.0.2-6

%description
Agda standard libraries


%package docs
Summary:        Agda standard libraries documentation
BuildArch:      noarch

%description docs
This package provides the html documentation for the stdlibs
generated by the Agda compiler program.


%global debug_package %{nil}


%prep
%setup -q -n agda-stdlib-%{version} -a1


%build
HOME=$PWD
%define cabal_configure_options --user
cd filemanip-%{filemanip_ver}
%ghc_lib_build filemanip %{filemanip_ver}
%ghc_lib_install filemanip %{filemanip_ver}
./Setup register --inplace
cd ..

%ghc_bin_build
dist/build/GenerateEverything/GenerateEverything

cd ffi
%ghc_lib_build agda-lib-ffi %{ffi_ver}
cd ..
agda -i. -isrc Everything.agda

agda --html -i. -isrc README.agda


%install
HOME=$PWD
cd ffi
%ghc_lib_install agda-lib-ffi %{ffi_ver}
./Setup register --inplace
mv *.files ..
cd ..
cat ghc-agda-lib-ffi*.files > haskell-ffi.files

mkdir -p %{buildroot}%{_datadir}/%{name}
cp -pr Everything.agda* src/* %{buildroot}%{_datadir}/%{name}


%check
agda -i. -isrc README.agda
rm README.agdai README/*.agdai


%post
%ghc_pkg_recache


%postun
%ghc_pkg_recache


%files -f haskell-ffi.files
%doc CHANGELOG LICENCE README*
%{_datadir}/%{name}


%files docs
%doc LICENCE html


%changelog
* Thu Apr 16 2015 Jens Petersen <petersen@redhat.com> - 0.9-1
- update to 0.9
- include ffi lib in main package

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jun 06 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Feb  5 2014 Jens Petersen <petersen@redhat.com> - 0.7-3
- no ghc-rpm-macros-extra on F19

* Mon Feb  3 2014 Jens Petersen <petersen@redhat.com> - 0.7-2
- only build on arch's where Agda builds

* Tue Jun 25 2013 Jens Petersen <petersen@redhat.com> - 0.7-1
- update to 0.7 with agda-lib-ffi-0.0.2
- use ghc-rpm-macros-extra
- add ffi_ver macro for agda-lib-ffi version

* Thu Jul 12 2012 Jens Petersen <petersen@redhat.com> - 0.6-4
- move stdlib files to datadir
- subpackage html docs

* Wed Jul 11 2012 Jens Petersen <petersen@redhat.com> - 0.6-3
- subpackage agda-lib-ffi for MAlonzo backend

* Wed Jul 11 2012 Jens Petersen <petersen@redhat.com> - 0.6-2
- fix the manifest to include the libraries
- add html
- turn off debuginfo
- remove README interface files

* Wed Jul 11 2012 Jens Petersen <petersen@redhat.com> - 0.6-1
- update to 0.6

* Sat Jun  4 2011 Fedora Haskell SIG <haskell-devel@lists.fedoraproject.org>
- initial packaging for Fedora automatically generated by cabal2spec-0.23
